<!-- Use this CSS stylesheet to ensure that add-ons styling 
     matches the default Google Docs styles -->

<style type="text/css">
  .float-right {
    float: right;
    margin-bottom: 8%;
  }

  .center {
    position: relative;
    left: 69px;
  }

  #data-panes {
    z-index: 8;
  }

  .margin-bottom {
    margin-bottom: 4%
  }

  .margin-top {
    margin-top: 20%;
  }

  .overlay {
    z-index: 7;
    opacity: 0.5;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    position: fixed;
    background: #222;
  }

  .overlay__inner {
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    position: absolute;
  }

  .overlay__content {
    left: 50%;
    position: absolute;
    top: 50%;
    transform: translate(-50%, -50%);
  }

  .spinner {
      width: 75px;
      height: 75px;
      display: inline-block;
      border-width: 2px;
      border-color: rgba(255, 255, 255, 0.05);
      border-top-color: #fff;
      animation: spin 1s infinite linear;
      border-radius: 100%;
      border-style: solid;
  }

  @keyframes spin {
    100% {
      transform: rotate(360deg);
    }
  }
</style>

<div id="loading_pane" class="overlay">
    <div class="overlay__inner">
        <div class="overlay__content"><span class="spinner"></span></div>
    </div>
</div>

<link href="https://ssl.gstatic.com/docs/script/css/add-ons.css"
     rel="stylesheet"> 

<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.css">

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.10.1/jquery.min.js">
</script>
  
<script type="text/javascript" charset="utf8" src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.js"></script>


<div id="data_panes">

  <div class="sidebar" id="data_pane" style="display: none;">
    <div class="float-right">
      <button class="create" id="add_property">Add Property</button>
    </div>

    <div id="no_property_msg" class="margin-top" style="display: none;">
      <p class="center"> No properties exist. Add one?</p>
    </div> 

    <table id="table_id" class="display">
      <thead>
        <tr id="show_key_value_header">
            <th>Key </th>
            <th>Value</th>
            <th></th>
            <th></th>
        </tr>
      </thead>
      <tbody>
          
      </tbody>
    </table>
  </div>

  <div id="edit_pane" class="center" style="display: none;">
    <h3>
      <span class="current">Edit property</span>
    </h3>

    <div class="form-group margin-bottom">
      <label for="city">Key</label>
      <input type="text" id="edit_key" disabled style="width: 160px;">
    </div>

    <div class="form-group margin-bottom">
      <label for="city">Value</label>
      <input type="text" id="edit_value" style="width: 160px;">
    </div>

    <p class="current" id="error_save_edit" style="display: none;">Add Value before saving</p>
    <button onclick="editProperty()" id="edit_property" class="create">Edit</button>
    <button onclick="selectPane('data_pane')">Close</button>

  </div>

  <div id="add_pane" class="center" style="display: none;">
    <h3>
      <span class="current">Add property</span>
    </h3>
    
    <div class="form-group margin-bottom">
      <label for="city">Key</label>
      <input type="text" id="add_key" style="width: 160px;">
    </div>

    <div class="form-group margin-bottom">
      <label for="city">Value</label>
      <input type="text" id="add_value" style="width: 160px;">
    </div>

    <p class="current" id="error_save_add" style="display: none;">Add Both Key Value before saving</p>
    <button class="create" id="create_property" onclick="addNewProperty()">Add</button>
    <button onclick="selectPane('data_pane')">Close</button>

  </div>

</div>


<script>

$(document).on('click', '.edit_line', function(){
   var key = $(this).data("key");
   var value = $(this).data("value");
   populateEditPane(key,value);
  });



$(document).on('click', '.delete_line', function(){
   var key = $(this).data("key");
   var value = $(this).data("value");
   
   getConfirmation(key);
  });



$(document).on('click', '#add_property', function(){
  refreshAddNew();
   selectPane("add_pane");
  });

function editProperty(){
//(old_key,new_key,value)
  $('#edit_property').prop('disabled', true)
  var key = $('#edit_key').val();
  var value = $('#edit_value').val();

  if(value=='') {
    $("#error_save_edit").show();
    $('#edit_property').prop('disabled', false)
  }
  else {
   google.script.run.withSuccessHandler(reloadDataPane)
          .addCustomProperty(key,value);
  }

}

function refreshAddNew() {
  $('#add_key').val('');
  $('#add_value').val('');
  $('#create_property').prop('disabled', false)
  
}


function addNewProperty() {
  $('#create_property').prop('disabled', true)
  var key = $('#add_key').val();
  var value = $('#add_value').val();

  if(key=='' || value=='') {
    $("#error_save_add").show();
    $('#create_property').prop('disabled', false)
  }
  else {
   google.script.run.withSuccessHandler(reloadDataPane)
          .addCustomProperty(key,value);
  }
}

function getConfirmation(key) {
  //$('#data_panes').hide();
  $('#loading_pane').show();
  google.script.run.withSuccessHandler(reloadDataPane)
          .showAlert(key);
}



function populateEditPane(key,value) {
  $("#error_save_edit").hide();
  $('#edit_key').val(key);
  $('#edit_value').val(value);
  $('#edit_property').prop('disabled', false)
  selectPane("edit_pane");
}

function selectPane(pane_id) {
  var pane_id_array = ["add_pane","edit_pane","data_pane"];

  for(var pane_array_key in pane_id_array) {
    if(pane_id_array[pane_array_key]==pane_id) {
      $('#'+pane_id).show();
    }
    else {
      $('#'+pane_id_array[pane_array_key]).hide();
    }
  }
  
}




function reloadDataPane() {
    $('#loading_pane').show();
    $('#show_key_value_header').hide();
    $('#table_id').DataTable().clear().destroy();
    //$('#table_id').empty();

    google.script.run.withSuccessHandler(displayTable)
            .getCustomProperties();

    selectPane("data_pane");
}



function displayTable(data) {
  var status = data.status;
  data = data.data
  if(status==1) {
    $('#no_property_msg').hide();

    $('#table_id').DataTable( {
    data: data,
    columns: [
        { data: 'key' },
        { data: 'value' },
        {
            mRender: function (data, type, row) {
                    var edit_link = '<a href="javascript:void();" class="edit_line" data-key="{key}" data-value="{value}">edit</a>';
                    edit_link = edit_link.replace('{key}',row.key);
                    edit_link = edit_link.replace('{value}',row.value);
                    return edit_link;
            }
        },
        {
            mRender: function (data, type, row) {
                    var delete_link = '<a href="javascript:void();" class="delete_line" data-key="{key}" data-value="{value}">delete</a>';
                    delete_link = delete_link.replace('{key}',row.key);
                    delete_link = delete_link.replace('{value}',row.value);
                    return delete_link;
            }
        }
    ],
        columnDefs: [
        { targets: [2,3], orderable: false}
      ]
  } );

  $('#loading_pane').hide();
  $('#data_panes').show();
  $('#show_key_value_header').show();
  $('#data_pane').show();
  }
  else {
    $('#loading_pane').hide();
    $('#data_panes').show();
    $('#show_key_value_header').hide();
    $('#data_pane').show();
    $('#no_property_msg').show();
  }
  
}



      
 // Attach click handlers after the Sidebar has loaded in Google Docs
 $(function() {
  
  google.script.run.withSuccessHandler(displayTable)
          .getCustomProperties();

  //google.script.run.insertGoogleMap($('#search').val());
   
 });
</script>
